/*-------------------------------------------------------------------------*\
 |                                                                         |
 |                                                                         |
 |  WE_EXT.H - Include file for WinEdit DLL Extension Processor            |
 |                                                                         |
 |                                                                         |
\*-------------------------------------------------------------------------*/




/*
 *  all extension commands fall in this range
 *
 */

#define WE_CMDFIRST               WM_USER +  100
#define WE_CMDLAST                WM_USER +  999



/*
 *  all user-defined command IDs must be in this range
 *
 */

#define WE_EXTFIRST               WM_USER + 500
#define WE_EXTLAST                WE_CMDLAST


/*
 *
 *  W M _ C O M M A N D   I D   V A L U E S
 *
 *
 *  Sample use shown in:    SAMPLES\TEMPLATE\WE_EXT.RC
 *
 *
 *  You can define menu items to use
 *  the following internal WinEdit command IDs.  Your DLL
 *  will NOT be called to handle these events.  You can
 *  also use SendMessage() or PostMessage() to send these
 *  command IDs as the wParam value in a WM_COMMAND message
 *  to WinEdit.
 *
 */


#define IDM_FILENEW                5001
#define IDM_FILEOPEN               5002
#define IDM_FILEMERGE              5003
#define IDM_FILELIST               5004
#define IDM_FILESAVE               5005
#define IDM_FILESAVEAS             5006
#define IDM_FILEPRINT              5007
#define IDM_FILEPRINTERSETUP       5008
#define IDM_FILEPAGESETUP          5009
#define IDM_FILESETPREF            5010
#define IDM_FILEKEYS               5011
#define IDM_FILEEXIT               5012

#define IDM_EDITUNDO               5013
#define IDM_EDITREDO               5014
#define IDM_EDITCUT                5015
#define IDM_EDITCOPY               5016
#define IDM_EDITPASTE              5017
#define IDM_EDITCLEAR              5018
#define IDM_EDITUP                 5019
#define IDM_EDITDOWN               5020
#define IDM_EDITLEFT               5021
#define IDM_EDITRIGHT              5022
#define IDM_EDITHOME               5023
#define IDM_EDITEND                5024
#define IDM_EDITPAGEUP             5025
#define IDM_EDITPAGEDOWN           5026
#define IDM_EDITWORDLEFT           5027
#define IDM_EDITWORDRIGHT          5028
#define IDM_EDITTOPOFFILE          5029
#define IDM_EDITENDOFFILE          5030
#define IDM_EDITTAB                5031
#define IDM_EDITBACKTAB            5032
#define IDM_EDITSELECTALL          5033
#define IDM_EDITSTARTSELECTION     5034
#define IDM_EDITENDSELECTION       5035
#define IDM_EDITSELECTLEFT         5036
#define IDM_EDITSELECTRIGHT        5037
#define IDM_EDITSELECTUP           5038
#define IDM_EDITSELECTDOWN         5039
#define IDM_EDITSELECTHOME         5040
#define IDM_EDITSELECTEND          5041
#define IDM_EDITSELECTPAGEUP       5042
#define IDM_EDITSELECTPAGEDOWN     5043
#define IDM_EDITSELECTWORDLEFT     5044
#define IDM_EDITSELECTWORDRIGHT    5045
#define IDM_EDITSELECTTOPOFFILE    5046
#define IDM_EDITSELECTENDOFFILE    5047
#define IDM_EDITTOGGLEWRAP         5048
#define IDM_EDITTOGGLEINS          5049
#define IDM_EDITTOGGLEAUTOINDENT   5050
#define IDM_EDITINSERTSTRING       5051
#define IDM_EDITBACKSPACE          5052
#define IDM_EDITCOPYLINE           5053
#define IDM_EDITCUTLINE            5054
#define IDM_EDITGOTOLINE           5055
#define IDM_EDITGOTOCOLUMN         5056
#define IDM_EDITSETCOLUMNBLOCK     5057

#define IDM_SEARCHFIND             5058
#define IDM_SEARCHNEXT             5059
#define IDM_SEARCHCHANGE           5060
#define IDM_SEARCHNEXTERR          5061
#define IDM_SEARCHPREVERR          5062
#define IDM_SEARCHVIEWEDOUT        5063

#define IDM_MACROSTARTRECORD       5064

#define IDM_COMPILE                5065
#define IDM_MAKE                   5066
#define IDM_REBUILD                5067
#define IDM_DEBUG                  5068
#define IDM_EXECUTE                5069
#define IDM_MAKECONFIG             5070

#define IDM_WINDOWMIN              5071
#define IDM_WINDOWMAX              5072
#define IDM_WINDOWNEXT             5073
#define IDM_WINDOWRESTORE          5074
#define IDM_WINDOWCLOSE            5075
#define IDM_WINDOWTILE             5076
#define IDM_WINDOWCASCADE          5077
#define IDM_WINDOWICONS            5078
#define IDM_WINDOWCLOSEALL         5079
#define IDM_WINDOWCHILD            5300

#define IDM_HELPINDEX              5081
#define IDM_HELPKEYBOARD           5082
#define IDM_HELPCOMMANDS           5083
#define IDM_HELPPROCEDURES         5084
#define IDM_HELPHELP               5085
#define IDM_HELPKEYWORDS           5086
#define IDM_HELPABOUT              5087

#define IDM_TOOLBAR                5206


/*
 *  Request and Notifications message IDs sent to your DLL by
 *  WinEdit.  Check the sample file WE_EXT.C and the
 *  documentation for details on the responses your DLL is
 *  expected to return to WinEdit.
 *
 */

#define WEN_LOADMENU               WE_CMDFIRST + 200
#define WEN_GETWINDOWMENU          WE_CMDFIRST + 201
#define WEN_GETMACROMENU           WE_CMDFIRST + 202
#define WEN_LOADSHORTMENU          WE_CMDFIRST + 203
#define WEN_END                    WE_CMDFIRST + 204
#define WEN_LOADACCELS             WE_CMDFIRST + 205
#define WEN_INITMENU               WE_CMDFIRST + 206
#define WEN_MACROSTARTPLAY         WE_CMDFIRST + 207
#define WEN_MACROSTOPPLAY          WE_CMDFIRST + 208
#define WEN_MACROSTARTRECORD       WE_CMDFIRST + 209
#define WEN_MACROSTOPRECORD        WE_CMDFIRST + 210
#define WEN_RBUTTONDOWN            WE_CMDFIRST + 211
#define WEN_RBUTTONDOWNC           WE_CMDFIRST + 212
#define WEN_RBUTTONDOWNS           WE_CMDFIRST + 213
#define WEN_RBUTTONDOWNSC          WE_CMDFIRST + 214


/*
 *  lParam struct used in the WEM_SEARCH* messages
 *  to pass the search and replace parameters
 */

typedef struct tagSEARCHRECORD
   {
   UINT      fComplain:    1;    /* show 'not found' etc. to user      */
   UINT      fPrompt:      1;    /* bring up search/replace dialog box */
   UINT      fMatchCase:   1;    /* exact case match only              */
   UINT      fForward:     1;    /* forward direction                  */
   UINT      fChangeAll:   1;    /* change all                         */
   UINT      fConfirm:     1;    /* ask user to confirm changes        */
   UINT      fRegular:     1;    /* use regular expression             */
   UINT      fUnused:      9;
   LPSTR     lpSearchText;       /* string to search for               */
   LPSTR     lpReplaceText;      /* string to replace found text with  */
   } SEARCHRECORD;

typedef SEARCHRECORD FAR *LPSEARCHRECORD;

/* icon ID values you can use with edAddButton and edDeleteButton */

#define IDLEXICON   6    /* main icon              */
#define IDNOTE      2    /* icon for child windows */
#define IDONEUP     4    /* one-up print icon      */
#define IDTWOUP     5    /* two-up print icon      */

#define OPEN       48    /* file open              */
#define SAVE       49    /* file save              */
#define PRINT      50    /* file print             */
#define FIND       51    /* find                   */
#define FINDNEXT   52    /* find next              */
#define CHANGE     53    /* change                 */
#define NEXT       54    /* next error             */
#define PREV       55    /* prev error             */
#define COMPILE    56    /* compile                */
#define MAKE       57    /* make                   */
#define REBUILD    58    /* rebuild                */
#define DEBUGICON  59    /* debug                  */
#define EXECUTE    60    /* execute                */
#define CUT        61    /* cut                    */
#define COPY       62    /* copy                   */
#define PASTE      63    /* paste                  */
#define HELPKEY    64    /* key word help          */
#define UNDO       65    /* undo                   */
#define REDO       66    /* redo                   */
#define FILELIST   67    /* filelist               */


/*
 *  function prototypes
 *
 */
int WINAPI edFileNew(HWND hWnd);
int WINAPI edFileOpen(HWND hWnd, LPSTR lpFileName);
int WINAPI edFileMerge(HWND hWnd, LPSTR lpFileName);
int WINAPI edFileSave(HWND hWnd);
int WINAPI edFileSaveAs(HWND hWnd, LPSTR lpFileName);
int WINAPI edFilePrint(HWND hWnd);
int WINAPI edFilePageSetup(HWND hWnd);
int WINAPI edFilePrinterSetup(HWND hWnd);
int WINAPI edFileSetPreferences(HWND hWnd);
int WINAPI edFileExit(HWND hWnd);
int WINAPI edFileList(HWND hWnd);

int WINAPI edEditUndo(HWND hWnd);
int WINAPI edEditRedo(HWND hWnd);
int WINAPI edEditCut(HWND hWnd);
int WINAPI edEditCopy(HWND hWnd);
int WINAPI edEditPaste(HWND hWnd);
int WINAPI edEditDelete(HWND hWnd);
int WINAPI edEditToggleIns(HWND hWnd);
int WINAPI edEditWrap(HWND hWnd);
int WINAPI edEditSetColumnBlock(HWND hWnd);
int WINAPI edEditInsertString(HWND hWnd, LPSTR lpString);
int WINAPI edEditBackspace(HWND hWnd);
int WINAPI edEditSelectAll(HWND hWnd);
int WINAPI edEditCopyLine(HWND hWnd);
int WINAPI edEditCutLine(HWND hWnd);
int WINAPI edEditGoToLine(HWND hWnd, int iLineNo);
int WINAPI edEditGoToColumn(HWND hWnd, int iColNo);
int WINAPI edEditBeginningOfLine(HWND hWnd);
int WINAPI edEditEndOfLine(HWND hWnd);
int WINAPI edEditBeginningOfFile(HWND hWnd);
int WINAPI edEditEndOfFile(HWND hWnd);
int WINAPI edEditUpLine(HWND hWnd);
int WINAPI edEditDownLine(HWND hWnd);
int WINAPI edEditLeft(HWND hWnd);
int WINAPI edEditRight(HWND hWnd);
int WINAPI edEditPageUp(HWND hWnd);
int WINAPI edEditPageDown(HWND hWnd);
int WINAPI edEditWordLeft(HWND hWnd);
int WINAPI edEditWordRight(HWND hWnd);
int WINAPI edEditStartSelection(HWND hWnd);
int WINAPI edEditEndSelection(HWND hWnd);
int WINAPI edEditClearSelection(HWND hWnd);
int WINAPI edEditSetBookMark(HWND hWnd, int iMark);
int WINAPI edEditGoToBookMark(HWND hWnd, int iMark);
int WINAPI edEditTab(HWND hWnd);
int WINAPI edEditBackTab(HWND hWnd);
int WINAPI edEditGetCurrentWord(HWND hWnd, LPSTR lpBuffer, int iLength);
int WINAPI edSearchFind(HWND hWnd, LPSEARCHRECORD lpSearch);
int WINAPI edSearchRepeat(HWND hWnd, LPSEARCHRECORD lpSearch);
int WINAPI edSearchChange(HWND hWnd, LPSEARCHRECORD lpSearch);
int WINAPI edSearchNextError(HWND hWnd);
int WINAPI edSearchPrevError(HWND hWnd);
int WINAPI edSearchViewOutput(HWND hWnd);

int WINAPI edRunCompile(HWND hWnd);
int WINAPI edRunMake(HWND hWnd);
int WINAPI edRunRebuild(HWND hWnd);
int WINAPI edRunDebug(HWND hWnd);
int WINAPI edRunExecute(HWND hWnd);
int WINAPI edRunCommand(HWND hWnd, BOOL bWait, BOOL bCapture, LPSTR lpCommand);
int WINAPI edRunConfigure(HWND hWnd);

int WINAPI edWindowTile(HWND hWnd);
int WINAPI edWindowCascade(HWND hWnd);
int WINAPI edWindowArrangeIcons(HWND hWnd);
int WINAPI edWindowNext(HWND hWnd);
int WINAPI edWindowMinimize(HWND hWnd);
int WINAPI edWindowMaximize(HWND hWnd);
int WINAPI edWindowRestore(HWND hWnd);
int WINAPI edWindowClose(HWND hWnd);
int WINAPI edWindowCloseAll(HWND hWnd);

int WINAPI edHelpIndex(HWND hWnd);
int WINAPI edHelpKeyboard(HWND hWnd);
int WINAPI edHelpCommands(HWND hWnd);
int WINAPI edHelpProcedures(HWND hWnd);
int WINAPI edHelpKeyWord(HWND hWnd);
int WINAPI edHelpHelp(HWND hWnd);
int WINAPI edHelpAbout(HWND hWnd);

int WINAPI edAddButton(HWND hWnd, WORD wIcon, WORD wCommand, WORD wPosition);
int WINAPI edDeleteButton(HWND hWnd, WORD wPosition, WORD wCommand);

int WINAPI edGetModifiedStatus(HWND hWnd);
int WINAPI edGetLineNumber(HWND hWnd);
int WINAPI edGetColumnNumber(HWND hWnd);
int WINAPI edGetSelectionState(HWND hWnd, LPPOINT ptStart, LPPOINT ptEnd);
int WINAPI edGetUndoState(HWND hWnd);
int WINAPI edGetRedoState(HWND hWnd);
int WINAPI edGetWordWrapState(HWND hWnd);
int WINAPI edGetInsertState(HWND hWnd);
int WINAPI edGetWindowName(HWND hWnd, LPSTR lpBuffer, int iSize);
int WINAPI edGetChar(HWND hWnd);
int WINAPI edRecord(HWND hWnd);
int WINAPI edStatusMsg(HWND hWnd, LPSTR lpString);
